///////////////////////////////////////////////
Config.appid = "Home";
Config.title = "Home";
Config.version = "1";

///////////////////////////////////////////////
function Home() {}
Home.welcome = function() {
	welcome();
}

Home.settings = function() {
	settings();
}

///////////////////////////////////////////////
function main() {
	if (Settings.isTablet()) {
		signIn();
		return;
	} else {
		if (Settings.getUsername() != null) {
			appList();
		} else {
			welcome();
	    }
	}
}
 
function leftPane() {
	List.addItem(R.SIGNIN, 'main()');
	List.addItem(R.CREATEACCOUNT, 'createAccount()');
	List.addItem(R.TRYDEMO, "App.signIn('demobiz@upvise.com', 'demobiz')");
	List.show("leftpane");
}

var APPS = new Array();
APPS["unybiz.calendar"] = {appid:"Calendar", img:'calendar'};
APPS["unybiz.contacts"] = {appid:"Contacts", img:'contact'};
APPS["uny.debtscredits"] = {appid:"DebtsCredits", img:'money'};
APPS["unybiz.delivery"] = {appid:"Delivery", img:'delivery'};
APPS["unybiz.expenses"] = {appid:"Expenses", img:'money'};
APPS["unybiz.files"] = {appid:"Files", img:'folder'};
APPS["unybiz.forms"] = {appid:"Forms", img:'form'};
APPS["unybiz.ideas"] = {appid:"Ideas", img:'idea'};
APPS["unybiz.medicalrecords"] = {appid:"MedicalRecords", img:'folderweb'};
APPS["uny.notes"] = {appid:"Notes", img:'note'};
APPS["unybiz.projects"] = {appid:"Projects", img:'project'};
APPS["uny.news"] = {appid:"News", img:'news'};
APPS["unybiz.sales"] = {appid:"Sales", img:'sale'};
APPS["uny.shoppinglist"] = {appid:"ShoppingList", img:'foldertask'};
APPS["unybiz.tasks"] = {appid:"Tasks", img:'foldertask'};
APPS["uny.wikipedia"] = {appid:"Wikipedia", img:'folderweb'};
APPS["unybiz.maintenance"] = {appid:"Maintenance", img:'maintenance'};

function getAppId(oldid) {
	var app = APPS[oldid];
	return app !=null ? app.appid : oldid;
}

function getImg(oldid) {
	var app = APPS[oldid];
	return app !=null ? app.img : "folderweb";
}

function appList() {
	Toolbar.setTitle(Settings.get("company"));
	Toolbar.addButton(R.NEWAPP, "newApp()", "new");
    var apps = Query.select("System.library", "id;title", null, "title");
    for (var i = 0; i < apps.length; i++) {
      var app = apps[i];
      var appid  = getAppId(app.id);
      var img = getImg(app.id);
      List.addItem(app.title, "App.open({appid})", "img=" + img);
    }
    List.show("grid");
}

function newApp() {
	App.alert("You can add new Upvise Apps and create your own on your Upvise Web Account.");
}

function welcome() {
    Toolbar.setTitle("Upvise");
    List.addItem(R.SIGNIN, 'signIn()', 'icon=bluearrow');
	List.addItem(R.CREATEACCOUNT, 'createAccount()', 'icon=bluearrow');
	List.addItem(R.TRYDEMO, "App.signIn('demobiz@upvise.com', 'demobiz')", 'icon=bluearrow');
	List.show();
}

function signIn() {
	List.addTextBox('email', R.EMAIL, '','','email');
    List.addTextBox('password', R.PASSWORD, '','','password');
    List.addButton(R.SIGNIN, 'onSignIn()');
    List.show();
}

function onSignIn() {
    var email = List.getValue('email');
    var password = List.getValue('password');
    App.signIn(email, password);
}

function createAccount() {
	List.addTextBox('email', R.EMAIL, '','','email');
    List.addTextBox('password', R.PASSWORD, '','','password');
    List.addTextBox('company', R.COMPANY, '','','text');
    List.addButton(R.CREATEACCOUNT, 'onCreateAccount()');
    List.show();
}

function onCreateAccount() {
    var email = List.getValue('email');
    var password = List.getValue('password');
    var company = List.getValue('company');
    App.signUp(email, password, company);
}

///////////////////
function settings() {
	if (Settings.get("username") == null) return;
	
	var salesTax = Query.selectId("System.settings", "sales-tax");
	if (salesTax != null) salesTax = salesTax.value;
	else salesTax = 0;
	var currency = Query.selectId("System.settings", "currency");
	if (currency != null) currency = currency.value;
	else currency = "USD";
	
	var onchange = "Query.updateId('System.settings',this.id,'value',this.value)";
			
	Toolbar.setTitle(R.SETTINGS);
	Toolbar.setStyle("edit");
	var syncOptions = "0:" + R.AUTOMATIC + "|1:" + R.WIFI + "|2:" + R.MANUAL;
	List.addComboBox('', R.SYNC, Settings.get('syncmode'), "Settings.set('syncmode', this.value)", syncOptions);
	List.addHeader(R.USERACCOUNT);
	List.addItemLabel(Settings.get("username"), Settings.get("email"));
	List.addButton(R.SIGNOUT, "App.signOut()");
	List.addHeader(R.CACHE);
	List.addItemLabel(R.CACHESIZE, Format.filesize(Settings.getCacheSize()));
	List.addButton(R.CLEARCACHE, "App.clearCache()");
	List.addHeader(R.SECURITY);
	List.addComboBox('', R.USEHTTPS, Settings.get('https'), "Settings.set('https', this.value)", "0:No|1:Yes");
	
	if (Settings.getPlatform() != "windowsphone") {
		var passcode = Settings.get("passcode");
		if (passcode == null || passcode.length == 0) {
			List.addItemLabel(R.PASSCODE, "No", "App.changePasscode()");
		} else {
			List.addItemLabel(R.PASSCODE, "Yes", "showPasscodeOptions()");
		}
	}
	List.addHeader(R.INTERNATIONAL);
	List.addTextBox('sales-tax', R.SALESTAX, salesTax, onchange, "percent");
	List.addTextBox('currency', R.CURRENCY, currency, onchange, "currency");
	
	var oncheckchange = "Settings.set(this.id,this.value)";
	if (Settings.getPlatform() == 'android') List.addCheckBox('logcall', R.LOGINCOMINGCALLS, Settings.get("logcall")=="1", oncheckchange);
	List.addCheckBox('bcc', R.BCCDROPBOX, Settings.get("bcc")=="1", oncheckchange);
		
	List.addHeader(R.ABOUT);
	List.addItemLabel(R.VERSION, Settings.getVersion());
	
	//List.addItem("Tests", "App.open('Tests')", "icon=bluearrow");
	List.show("form");
}

function showPasscodeOptions() {
	List.addItem("Turn Off", "App.turnOffPasscode()");
	List.addItem("Change", "App.changePasscode()");
	List.show("popup");
}
